/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "tim.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "lcd.h"

void blink(void){
	HAL_GPIO_WritePin(GPIOC, LED_Pin, LOW);
	HAL_Delay(100);
	HAL_GPIO_WritePin(GPIOC, LED_Pin, HIGH);
	HAL_Delay(100);
}

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
 short int aux=0, i=0;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  MX_TIM10_Init();
  /* USER CODE BEGIN 2 */
	 HAL_TIM_Base_Start(&htim10);  
   LCD_init();
	 LCD_Clear();
	 LCD_SetPos(4, 0);
	 LCD_String("KEY:");
	 HAL_Delay(100);
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
		LCD_SetPos(aux, 1);
		
		for(i=0;i<4;i++){ 
			
			HAL_GPIO_WritePin(GPIOA,ROW1_Pin,LOW);
			HAL_GPIO_WritePin(GPIOA,ROW2_Pin|ROW3_Pin|ROW4_Pin, HIGH);
			
			HAL_Delay(5);
			
			if(HAL_GPIO_ReadPin(GPIOB, COL1_Pin)==LOW && i==0) LCD_String("1"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL2_Pin)==LOW && i==0) LCD_String("2"), blink(), aux++;
			if(HAL_GPIO_ReadPin(GPIOB, COL3_Pin)==LOW && i==0) LCD_String("3"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL4_Pin)==LOW && i==0) LCD_String("A"), blink(), aux++;
			
			HAL_GPIO_WritePin(GPIOA,ROW2_Pin,LOW);
			HAL_GPIO_WritePin(GPIOA,ROW1_Pin|ROW3_Pin|ROW4_Pin, HIGH);
			
			HAL_Delay(5);
			
			if(HAL_GPIO_ReadPin(GPIOB, COL1_Pin)==LOW && i==1) LCD_String("4"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL2_Pin)==LOW && i==1) LCD_String("5"), blink(), aux++;
			if(HAL_GPIO_ReadPin(GPIOB, COL3_Pin)==LOW && i==1) LCD_String("6"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL4_Pin)==LOW && i==1) LCD_String("B"), blink(), aux++;
			
		  HAL_GPIO_WritePin(GPIOA,ROW3_Pin,LOW);
			HAL_GPIO_WritePin(GPIOA,ROW1_Pin|ROW2_Pin|ROW4_Pin, HIGH);
			
			HAL_Delay(5);
			
		  if(HAL_GPIO_ReadPin(GPIOB, COL1_Pin)==LOW && i==2) LCD_String("7"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL2_Pin)==LOW && i==2) LCD_String("8"), blink(), aux++;
			if(HAL_GPIO_ReadPin(GPIOB, COL3_Pin)==LOW && i==2) LCD_String("9"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL4_Pin)==LOW && i==2) LCD_String("C"), blink(), aux++;
			
			HAL_GPIO_WritePin(GPIOA,ROW4_Pin,LOW);
			HAL_GPIO_WritePin(GPIOA,ROW1_Pin|ROW2_Pin|ROW3_Pin, HIGH);
			
			HAL_Delay(5);
			
			if(HAL_GPIO_ReadPin(GPIOB, COL1_Pin)==LOW && i==3) LCD_String("*"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL2_Pin)==LOW && i==3) LCD_String("0"), blink(), aux++;
			if(HAL_GPIO_ReadPin(GPIOB, COL3_Pin)==LOW && i==3) LCD_String("#"), blink(), aux++;
      if(HAL_GPIO_ReadPin(GPIOB, COL4_Pin)==LOW && i==3) LCD_String("D"), blink(), aux++;
			
		 }
		 
		  if(aux>15) aux=0;  
		 
  }
		
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 12;
  RCC_OscInitStruct.PLL.PLLN = 96;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
